#include "boxman.h"
#define NR_LEVELS 2

char fig[4][8][8]; // 4 figuri: BoxMan,cutie,target,perete
int x_om=2,y_om=5,gridsize=8,fig_size=6,current_level=0;
int press_once=1,pressed;
char level[NR_LEVELS][8][8];    //indicele figurilor de pe fiecare pozitie
int toggle=1, toggle_x=1, next_level=1;

void initButtons() {
    
	DDRD  &= ~(1 << LEFT_BUTTON);
	PORTD |= 1 << LEFT_BUTTON;
	DDRD  &= ~(1 << UP_BUTTON);
	PORTD |= 1 << UP_BUTTON;
	DDRD  &= ~(1 << RIGHT_BUTTON);
	PORTD |= 1 << RIGHT_BUTTON;
	DDRD  &= ~(1 << DOWN_BUTTON);
	PORTD |= 1 << DOWN_BUTTON;
	DDRD  &= ~(1 << CTRL_BUTTON);
	PORTD |= 1 << CTRL_BUTTON;
}

void init_fig(){

    //BoxMan    
    fig[0][0][2]=1;
    fig[0][0][3]=1;
    fig[0][1][0]=1;
    fig[0][1][2]=1;
    fig[0][1][3]=1;
    fig[0][1][5]=1;
    fig[0][2][1]=1;
    fig[0][2][4]=1;
    fig[0][3][2]=1;
    fig[0][3][3]=1;
    fig[0][4][1]=1;
    fig[0][4][2]=1;
    fig[0][4][3]=1;
    fig[0][4][4]=1;
    fig[0][5][1]=1;
    fig[0][5][4]=1;
    
    //cutie
    fig[1][0][0]=1;
    fig[1][0][2]=1;
    fig[1][0][3]=1;
    fig[1][0][5]=1;
    fig[1][1][1]=1;
    fig[1][1][4]=1;
    fig[1][2][0]=1;
    fig[1][2][5]=1;
    fig[1][3][0]=1;
    fig[1][3][5]=1;
    fig[1][4][1]=1;
    fig[1][4][4]=1;
    fig[1][5][0]=1;
    fig[1][5][2]=1;
    fig[1][5][3]=1;
    fig[1][5][5]=1;
    
    //target
    fig[2][1][1]=1;
    fig[2][1][4]=1;
    fig[2][2][2]=1;
    fig[2][2][3]=1;
    fig[2][3][2]=1;
    fig[2][3][3]=1;
    fig[2][4][1]=1;
    fig[2][4][4]=1;
    
    //perete
    int i,j;
    for (i=1;i<5;i++)
        for (j=1;j<5;j++)
            fig[3][i][j]=1;
}

void init_levels(){
    
    if (current_level==0){
        x_om=3;
        y_om=5;
        if (next_level){
            LcdGotoXYFont(5,3);
    	   LcdStr(FONT_1X, "Level 1");
	       LcdUpdate();
    	   _delay_ms(1000);
        }
    }
    if (current_level==1){
        x_om=4;
        y_om=3;
        if (next_level){
            LcdGotoXYFont(5,3);
    	   LcdStr(FONT_1X, "Level 2");
	       LcdUpdate();
    	   _delay_ms(1000);
        }
    }
    next_level=0;
    LcdClear();
    level[0][0][0]=3;
    level[0][0][1]=3;
    level[0][0][2]=3;
    level[0][0][3]=3;  
    level[0][0][4]=3;  
    level[0][0][5]=3;  
    level[0][0][6]=3;
    level[0][0][7]=3; 
    level[0][1][0]=3;
    level[0][1][1]=3;
    level[0][1][2]=3;
    level[0][1][3]=4;  
    level[0][1][4]=4;  
    level[0][1][5]=3;  
    level[0][1][6]=3;
    level[0][1][7]=3; 
    level[0][2][0]=3;
    level[0][2][1]=3;
    level[0][2][2]=3;
    level[0][2][3]=1;  
    level[0][2][4]=4;  
    level[0][2][5]=3;  
    level[0][2][6]=3;
    level[0][2][7]=3; 
    level[0][3][0]=3;
    level[0][3][1]=4;
    level[0][3][2]=1;
    level[0][3][3]=4;  
    level[0][3][4]=4;  
    level[0][3][5]=4;  
    level[0][3][6]=3;
    level[0][3][7]=3; 
    level[0][4][0]=3;
    level[0][4][1]=4;
    level[0][4][2]=2;
    level[0][4][3]=2;  
    level[0][4][4]=2;  
    level[0][4][5]=4;  
    level[0][4][6]=3;
    level[0][4][7]=3; 
    level[0][5][0]=3;
    level[0][5][1]=3;
    level[0][5][2]=1;
    level[0][5][3]=4;  
    level[0][5][4]=4;  
    level[0][5][5]=3;  
    level[0][5][6]=3;
    level[0][5][7]=3; 
    level[0][6][0]=3;
    level[0][6][1]=3;
    level[0][6][2]=4;
    level[0][6][3]=4;  
    level[0][6][4]=3;  
    level[0][6][5]=3;  
    level[0][6][6]=3;
    level[0][6][7]=3; 
    level[0][7][0]=3;
    level[0][7][1]=3;
    level[0][7][2]=3;
    level[0][7][3]=3;  
    level[0][7][4]=3;  
    level[0][7][5]=3;  
    level[0][7][6]=3;
    level[0][7][7]=3;
    
    level[1][0][0]=3;
    level[1][0][1]=3;
    level[1][0][2]=3;
    level[1][0][3]=3;  
    level[1][0][4]=3;  
    level[1][0][5]=3;  
    level[1][0][6]=3;
    level[1][0][7]=3; 
    level[1][1][0]=3;
    level[1][1][1]=2;
    level[1][1][2]=3;
    level[1][1][3]=4;  
    level[1][1][4]=4;  
    level[1][1][5]=3;  
    level[1][1][6]=3;
    level[1][1][7]=3; 
    level[1][2][0]=3;
    level[1][2][1]=2;
    level[1][2][2]=2;
    level[1][2][3]=2;  
    level[1][2][4]=4;  
    level[1][2][5]=4;  
    level[1][2][6]=3;
    level[1][2][7]=3; 
    level[1][3][0]=3;
    level[1][3][1]=4;
    level[1][3][2]=3;
    level[1][3][3]=5;  
    level[1][3][4]=4;  
    level[1][3][5]=4;  
    level[1][3][6]=4;
    level[1][3][7]=3; 
    level[1][4][0]=3;
    level[1][4][1]=4;
    level[1][4][2]=1;
    level[1][4][3]=2;  
    level[1][4][4]=3;  
    level[1][4][5]=4;  
    level[1][4][6]=4;
    level[1][4][7]=3; 
    level[1][5][0]=3;
    level[1][5][1]=3;
    level[1][5][2]=4;
    level[1][5][3]=1;  
    level[1][5][4]=4;  
    level[1][5][5]=1;  
    level[1][5][6]=4;
    level[1][5][7]=3; 
    level[1][6][0]=3;
    level[1][6][1]=3;
    level[1][6][2]=1;
    level[1][6][3]=4;  
    level[1][6][4]=1;  
    level[1][6][5]=4;  
    level[1][6][6]=3;
    level[1][6][7]=3; 
    level[1][7][0]=3;
    level[1][7][1]=3;
    level[1][7][2]=4;
    level[1][7][3]=4;  
    level[1][7][4]=4;  
    level[1][7][5]=3;  
    level[1][7][6]=3;
    level[1][7][7]=3; 
}

void win_check(){
 
    int found=0,i,j;
    for (i=0;i<gridsize;i++)
        for (j=0;j<gridsize;j++)
            if (level[current_level][i][j]==1)//cutiile pe pozitii finale sunt codate cu 5
                found=1;
    if (!found){//daca nu am gasit nici o cutie nepozitionata (cod 1)
        next_level=1;
        if (current_level==NR_LEVELS-1){
            LcdGotoXYFont(5,3);
    	    LcdStr(FONT_1X, "You Win!");
	        LcdUpdate();
           	_delay_ms(1000);
        }
        init_levels();
        current_level=(current_level+1)%NR_LEVELS;   //go to next level
    }
}

int evaluate_move(int x, int y){

    int aux;
    if (x<0||x>8||y<0||y>8)
        return 0;
    if (level[current_level][x][y]==3)
        return 0;
    if (level[current_level][x][y]==4||level[current_level][x][y]==2)
        return 1;
    aux=level[current_level][x+(x-x_om)][y+(y-y_om)];
    if (level[current_level][x][y]==1){
        if (aux==4){            
            //level[current_level][x][y]==4; //Un bug incredibil, a trebuit sa fac +x-x ca sa mearga
            level[current_level][x+(x-x_om)-(x-x_om)][y+(y-y_om)-(y-y_om)]=4;
            level[current_level][x+(x-x_om)][y+(y-y_om)]=1;
            return 1;
        }
        if (aux==2){            
            //level[current_level][x][y]==4;
            level[current_level][x+(x-x_om)-(x-x_om)][y+(y-y_om)-(y-y_om)]=4;
            level[current_level][x+(x-x_om)][y+(y-y_om)]=5;
            return 1;
        }
    }
    if (level[current_level][x][y]==5){
        if (aux==4){            
            //level[current_level][x][y]==4;
            level[current_level][x+(x-x_om)-(x-x_om)][y+(y-y_om)-(y-y_om)]=2;
            level[current_level][x+(x-x_om)][y+(y-y_om)]=1;
            return 1;
        }
        if (aux==2){            
            //level[current_level][x][y]==4;
            level[current_level][x+(x-x_om)-(x-x_om)][y+(y-y_om)-(y-y_om)]=2;
            level[current_level][x+(x-x_om)][y+(y-y_om)]=5;
            return 1;
        }
    }
    return 0;
}

void checkButtons() {

	if ((PIND & (1 << LEFT_BUTTON)) == 0) {
        if (press_once)
        if (evaluate_move(x_om-1,y_om)){
            x_om--;
            press_once=0;
        }
        pressed=1;
		return;
	}
	
	if ((PIND & (1 << UP_BUTTON)) == 0) {
        if (press_once)        
        if (evaluate_move(x_om,y_om-1)){
            y_om--;
            press_once=0;
        }
        pressed=1;
		return;
	}
	
	if ((PIND & (1 << RIGHT_BUTTON)) == 0) {
        if (press_once)
        if (evaluate_move(x_om+1,y_om)){
            x_om++;
            press_once=0;
        }
        pressed=1;
		return;
	}
	
	if ((PIND & (1 << DOWN_BUTTON)) == 0) {
        if (press_once)
        if (evaluate_move(x_om,y_om+1)){
            press_once=0;
            y_om++;
        }
        pressed=1;
		return;
	}
	if ((PIND & (1 << CTRL_BUTTON)) == 0) {
        if (press_once)
        init_levels();
        pressed=1;
		return;
	}
	press_once=1;
}



void draw_fig(){

    
    int i,j,k,l;
    for (k=0;k<gridsize;k++)
        for (l=0;l<gridsize;l++){
            if (level[current_level][k][l]==4)
                continue;
            if (level[current_level][k][l]==5){
                for (i=0;i<6;i++)
                    for (j=0;j<6;j++)
                        if (fig[1][i][j]==1)
        	       	        LcdPixel(l*fig_size+j, k*fig_size+i, PIXEL_ON);
        	    if (toggle)
        	    for (i=0;i<6;i++)
                    for (j=0;j<6;j++)
                        if (fig[2][i][j]==1)
        	       	        LcdPixel(l*fig_size+j, k*fig_size+i, PIXEL_ON);
        	    continue;
            }
            for (i=0;i<6;i++)
                for (j=0;j<6;j++)
                    if (fig[level[current_level][k][l]][i][j]==1)
        	       	   LcdPixel(l*fig_size+j, k*fig_size+i, PIXEL_ON);
        	/*
        	if (level[current_level][k][l]==2){
                if (rand_n%4==0)
                     LcdPixel(l*fig_size+1, k*fig_size+1, PIXEL_OFF);
                if (rand_n%4==0)
                     LcdPixel(l*fig_size+1, k*fig_size+4, PIXEL_OFF);
                if (rand_n%4==0)
                     LcdPixel(l*fig_size+4, k*fig_size+1, PIXEL_OFF);
                if (rand_n%4==0)
                     LcdPixel(l*fig_size+4, k*fig_size+4, PIXEL_OFF);               
            }*/
        }     
   for (i=0;i<6;i++)
        for (j=0;j<6;j++)
            if (fig[0][i][j]==1)
                LcdPixel(y_om*fig_size+j, x_om*fig_size+i, PIXEL_ON);
            else
                //if (toggle_x%5)
                LcdPixel(y_om*fig_size+j, x_om*fig_size+i, PIXEL_OFF);
    if (level[current_level][x_om][y_om]==2&&toggle_x%5==0){
         LcdPixel(y_om*fig_size+0, x_om*fig_size+1, PIXEL_OFF);
         LcdPixel(y_om*fig_size+5, x_om*fig_size+1, PIXEL_OFF);
         LcdPixel(y_om*fig_size+1, x_om*fig_size+1, PIXEL_ON);
         LcdPixel(y_om*fig_size+4, x_om*fig_size+1, PIXEL_ON);
    }
    toggle_x=(toggle_x+1)%5;
}           



int main() {

    
    init_fig();
 
    initButtons();
	LcdInit();
    LcdClear();
    
   	LcdGotoXYFont(5,3);
	LcdStr(FONT_1X, "BoxMan");
	LcdUpdate();
	_delay_ms(1000);
	
	init_levels();
    
	int i;
    int count=0;
	while (1) {
		LcdClear();
		pressed=0;
		count=0;
        while (!pressed&&count<10){
            count++;
            checkButtons();
    	   _delay_ms(5);
        }
        toggle=1-toggle;
    	
		draw_fig();
		win_check();
		LcdUpdate();		
	}
	return 0;
}
